'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_reactClickCopy__XT_qT {\n  display: inline-block;\n  position: relative;\n}\n.styles_textarea__2dNqO {\n  position: absolute;\n  opacity: 0;\n  width: 0;\n  height: 0;\n  border: none;\n  outline: none;\n  resize: none;\n}\n.styles_btnDefault__3_Glg {\n  background: transparent;\n  border: 0.125em solid #42a5f5;\n  color: #42a5f5;\n  font-size: 16px;\n  padding: 0.25em 1em;\n  border-radius: 0.25em;\n  cursor: pointer;\n}\n.styles_popover__1Kcnf {\n  position: absolute;\n  overflow: visible;\n  min-width: 200px;\n  top: -8px;\n  left: 50%;\n  transform: translate(-50%, -100%);\n  margin: 0;\n  background: white;\n  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.5);\n  font-size: 14px;\n  padding: 0.5em 0;\n}\n.styles_popover__1Kcnf:before {\n  content: \"\";\n  width: 8px;\n  height: 8px;\n  position: absolute;\n  bottom: -4px;\n  left: calc(50% - 5px);\n  background: white;\n  transform: rotate(45deg);\n  z-index: -1;\n}\n.styles_popoverBgOverlay__3bdJe {\n  position: fixed;\n  top: 0;\n  left: 0;\n  /* z-index: -2; */\n  width: 100%;\n  height: 100%;\n}\n";
var styles = { "reactClickCopy": "styles_reactClickCopy__XT_qT", "textarea": "styles_textarea__2dNqO", "btnDefault": "styles_btnDefault__3_Glg", "popover": "styles_popover__1Kcnf", "popoverBgOverlay": "styles_popoverBgOverlay__3bdJe" };
styleInject(css);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var ClickToCopy = function (_Component) {
  inherits(ClickToCopy, _Component);

  function ClickToCopy(props) {
    classCallCheck(this, ClickToCopy);

    var _this = possibleConstructorReturn(this, (ClickToCopy.__proto__ || Object.getPrototypeOf(ClickToCopy)).call(this, props));

    _this.copyToClipboard = function (e) {
      _this.textAreaRef.current.select();
      document.execCommand('copy');
      if (_this.props.onCopy) {
        _this.props.onCopy();
      } else {
        _this.togglePopover();
      }
    };

    _this.textAreaRef = React__default.createRef();
    _this.state = {
      popoverVisible: false
    };
    return _this;
  }

  createClass(ClickToCopy, [{
    key: 'togglePopover',
    value: function togglePopover() {
      var _this2 = this;

      if (this.state.popoverVisible) {
        if (this.popoverTimeout) {
          clearTimeout(this.popoverTimeout);
        }
        this.setState({
          popoverVisible: false
        });
      } else {
        this.setState({
          popoverVisible: true
        }, function () {
          _this2.popoverTimeout = setTimeout(function () {
            _this2.setState({
              popoverVisible: false
            });
          }, 3000);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React__default.createElement(
        'form',
        { className: styles.reactClickCopy },
        React__default.createElement(
          'div',
          {
            style: {
              display: this.state.popoverVisible ? 'block' : 'none'
            },
            className: styles.popover
          },
          'Copied Successfully!'
        ),
        React__default.createElement('div', {
          className: styles.popoverBgOverlay,
          style: {
            visibility: this.state.popoverVisible ? 'visible' : 'hidden'
          },
          onClick: function onClick() {
            return _this3.togglePopover();
          }
        }),
        React__default.createElement('textarea', {
          className: styles.textarea,
          ref: this.textAreaRef,
          value: this.props.contentToCopy,
          rows: 0,
          cols: 0,
          readOnly: true
        }),
        this.props.render ? this.props.render({ copy: this.copyToClipboard }) : React__default.createElement(
          'button',
          {
            type: 'button',
            className: styles.btnDefault,
            onClick: this.copyToClipboard
          },
          'Copy'
        )
      );
    }
  }]);
  return ClickToCopy;
}(React.Component);

ClickToCopy.propTypes = {
  contentToCopy: PropTypes.string.isRequired
};

module.exports = ClickToCopy;
//# sourceMappingURL=index.js.map
